
#define IOBUFSIZE (64*1024)

static int max_pos = IOBUFSIZE;
static int curr_pos = IOBUFSIZE;
static unsigned char iobuf [IOBUFSIZE];

static inline int my_getc (int file)
{
	int len;
	int c;

	if (curr_pos == max_pos) {
		curr_pos = 0;
		len = read(file, iobuf, IOBUFSIZE);
		if (len != IOBUFSIZE) {
			if (len <= 0) {
				max_pos = 0;
				c = -1;
				goto out;
			}
			max_pos = len;
		}
	}
	c = iobuf[curr_pos];
	curr_pos++;
out:
//	printf("returning unsigned char: %c (%d)\n", c, c);
	return c;
}

static inline int my_read (int file, void *buf, int bytes)
{
	int i;
	unsigned char *tmp = (unsigned char *)buf;

	for (i = 0; i < bytes; i++) {
		int c;
		c = my_getc(file);
		if (c == -1)
			return i;
		tmp[i] = (unsigned char)c;
	}
	return  bytes;
}

